// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package users

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/members/members_models"
)

// PutUsersReader is a Reader for the PutUsers structure.
type PutUsersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutUsersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutUsersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutUsersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutUsersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutUsersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutUsersUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutUsersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutUsersOK creates a PutUsersOK with default headers values
func NewPutUsersOK() *PutUsersOK {
	return &PutUsersOK{}
}

/*
PutUsersOK describes a response with status code 200, with default header values.

Response with User objects
*/
type PutUsersOK struct {
	Payload *members_models.UserResponse
}

// IsSuccess returns true when this put users o k response has a 2xx status code
func (o *PutUsersOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this put users o k response has a 3xx status code
func (o *PutUsersOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put users o k response has a 4xx status code
func (o *PutUsersOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this put users o k response has a 5xx status code
func (o *PutUsersOK) IsServerError() bool {
	return false
}

// IsCode returns true when this put users o k response a status code equal to that given
func (o *PutUsersOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the put users o k response
func (o *PutUsersOK) Code() int {
	return 200
}

func (o *PutUsersOK) Error() string {
	return fmt.Sprintf("[PUT /users][%d] putUsersOK  %+v", 200, o.Payload)
}

func (o *PutUsersOK) String() string {
	return fmt.Sprintf("[PUT /users][%d] putUsersOK  %+v", 200, o.Payload)
}

func (o *PutUsersOK) GetPayload() *members_models.UserResponse {
	return o.Payload
}

func (o *PutUsersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.UserResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutUsersUnauthorized creates a PutUsersUnauthorized with default headers values
func NewPutUsersUnauthorized() *PutUsersUnauthorized {
	return &PutUsersUnauthorized{}
}

/*
PutUsersUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PutUsersUnauthorized struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this put users unauthorized response has a 2xx status code
func (o *PutUsersUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put users unauthorized response has a 3xx status code
func (o *PutUsersUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put users unauthorized response has a 4xx status code
func (o *PutUsersUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this put users unauthorized response has a 5xx status code
func (o *PutUsersUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this put users unauthorized response a status code equal to that given
func (o *PutUsersUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the put users unauthorized response
func (o *PutUsersUnauthorized) Code() int {
	return 401
}

func (o *PutUsersUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /users][%d] putUsersUnauthorized  %+v", 401, o.Payload)
}

func (o *PutUsersUnauthorized) String() string {
	return fmt.Sprintf("[PUT /users][%d] putUsersUnauthorized  %+v", 401, o.Payload)
}

func (o *PutUsersUnauthorized) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PutUsersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutUsersForbidden creates a PutUsersForbidden with default headers values
func NewPutUsersForbidden() *PutUsersForbidden {
	return &PutUsersForbidden{}
}

/*
PutUsersForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutUsersForbidden struct {
	AccessControlAllowOrigin string

	Payload *members_models.Error
}

// IsSuccess returns true when this put users forbidden response has a 2xx status code
func (o *PutUsersForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put users forbidden response has a 3xx status code
func (o *PutUsersForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put users forbidden response has a 4xx status code
func (o *PutUsersForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this put users forbidden response has a 5xx status code
func (o *PutUsersForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this put users forbidden response a status code equal to that given
func (o *PutUsersForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the put users forbidden response
func (o *PutUsersForbidden) Code() int {
	return 403
}

func (o *PutUsersForbidden) Error() string {
	return fmt.Sprintf("[PUT /users][%d] putUsersForbidden  %+v", 403, o.Payload)
}

func (o *PutUsersForbidden) String() string {
	return fmt.Sprintf("[PUT /users][%d] putUsersForbidden  %+v", 403, o.Payload)
}

func (o *PutUsersForbidden) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PutUsersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutUsersNotFound creates a PutUsersNotFound with default headers values
func NewPutUsersNotFound() *PutUsersNotFound {
	return &PutUsersNotFound{}
}

/*
PutUsersNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutUsersNotFound struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this put users not found response has a 2xx status code
func (o *PutUsersNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put users not found response has a 3xx status code
func (o *PutUsersNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put users not found response has a 4xx status code
func (o *PutUsersNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this put users not found response has a 5xx status code
func (o *PutUsersNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this put users not found response a status code equal to that given
func (o *PutUsersNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the put users not found response
func (o *PutUsersNotFound) Code() int {
	return 404
}

func (o *PutUsersNotFound) Error() string {
	return fmt.Sprintf("[PUT /users][%d] putUsersNotFound  %+v", 404, o.Payload)
}

func (o *PutUsersNotFound) String() string {
	return fmt.Sprintf("[PUT /users][%d] putUsersNotFound  %+v", 404, o.Payload)
}

func (o *PutUsersNotFound) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PutUsersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutUsersUnprocessableEntity creates a PutUsersUnprocessableEntity with default headers values
func NewPutUsersUnprocessableEntity() *PutUsersUnprocessableEntity {
	return &PutUsersUnprocessableEntity{}
}

/*
PutUsersUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutUsersUnprocessableEntity struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this put users unprocessable entity response has a 2xx status code
func (o *PutUsersUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put users unprocessable entity response has a 3xx status code
func (o *PutUsersUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put users unprocessable entity response has a 4xx status code
func (o *PutUsersUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this put users unprocessable entity response has a 5xx status code
func (o *PutUsersUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this put users unprocessable entity response a status code equal to that given
func (o *PutUsersUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the put users unprocessable entity response
func (o *PutUsersUnprocessableEntity) Code() int {
	return 422
}

func (o *PutUsersUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /users][%d] putUsersUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutUsersUnprocessableEntity) String() string {
	return fmt.Sprintf("[PUT /users][%d] putUsersUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutUsersUnprocessableEntity) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PutUsersUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutUsersInternalServerError creates a PutUsersInternalServerError with default headers values
func NewPutUsersInternalServerError() *PutUsersInternalServerError {
	return &PutUsersInternalServerError{}
}

/*
PutUsersInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutUsersInternalServerError struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this put users internal server error response has a 2xx status code
func (o *PutUsersInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put users internal server error response has a 3xx status code
func (o *PutUsersInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put users internal server error response has a 4xx status code
func (o *PutUsersInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this put users internal server error response has a 5xx status code
func (o *PutUsersInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this put users internal server error response a status code equal to that given
func (o *PutUsersInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the put users internal server error response
func (o *PutUsersInternalServerError) Code() int {
	return 500
}

func (o *PutUsersInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /users][%d] putUsersInternalServerError  %+v", 500, o.Payload)
}

func (o *PutUsersInternalServerError) String() string {
	return fmt.Sprintf("[PUT /users][%d] putUsersInternalServerError  %+v", 500, o.Payload)
}

func (o *PutUsersInternalServerError) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PutUsersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
