// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package industry

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetIndustriesParams creates a new GetIndustriesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetIndustriesParams() *GetIndustriesParams {
	return &GetIndustriesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetIndustriesParamsWithTimeout creates a new GetIndustriesParams object
// with the ability to set a timeout on a request.
func NewGetIndustriesParamsWithTimeout(timeout time.Duration) *GetIndustriesParams {
	return &GetIndustriesParams{
		timeout: timeout,
	}
}

// NewGetIndustriesParamsWithContext creates a new GetIndustriesParams object
// with the ability to set a context for a request.
func NewGetIndustriesParamsWithContext(ctx context.Context) *GetIndustriesParams {
	return &GetIndustriesParams{
		Context: ctx,
	}
}

// NewGetIndustriesParamsWithHTTPClient creates a new GetIndustriesParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetIndustriesParamsWithHTTPClient(client *http.Client) *GetIndustriesParams {
	return &GetIndustriesParams{
		HTTPClient: client,
	}
}

/*
GetIndustriesParams contains all the parameters to send to the API endpoint

	for the get industries operation.

	Typically these are written to a http.Request.
*/
type GetIndustriesParams struct {

	/* IndustryID.

	   Industry record ID
	*/
	IndustryID *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	/* ProductCategory.

	   Is this industry a product category?
	*/
	ProductCategory *bool

	/* ServiceCategory.

	   Is this industry a service category?
	*/
	ServiceCategory *bool

	/* Slug.

	   The Slug of this Object
	*/
	Slug *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get industries params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetIndustriesParams) WithDefaults() *GetIndustriesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get industries params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetIndustriesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get industries params
func (o *GetIndustriesParams) WithTimeout(timeout time.Duration) *GetIndustriesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get industries params
func (o *GetIndustriesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get industries params
func (o *GetIndustriesParams) WithContext(ctx context.Context) *GetIndustriesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get industries params
func (o *GetIndustriesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get industries params
func (o *GetIndustriesParams) WithHTTPClient(client *http.Client) *GetIndustriesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get industries params
func (o *GetIndustriesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndustryID adds the industryID to the get industries params
func (o *GetIndustriesParams) WithIndustryID(industryID *string) *GetIndustriesParams {
	o.SetIndustryID(industryID)
	return o
}

// SetIndustryID adds the industryId to the get industries params
func (o *GetIndustriesParams) SetIndustryID(industryID *string) {
	o.IndustryID = industryID
}

// WithLimit adds the limit to the get industries params
func (o *GetIndustriesParams) WithLimit(limit *int64) *GetIndustriesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get industries params
func (o *GetIndustriesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get industries params
func (o *GetIndustriesParams) WithOffset(offset *int64) *GetIndustriesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get industries params
func (o *GetIndustriesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithProductCategory adds the productCategory to the get industries params
func (o *GetIndustriesParams) WithProductCategory(productCategory *bool) *GetIndustriesParams {
	o.SetProductCategory(productCategory)
	return o
}

// SetProductCategory adds the productCategory to the get industries params
func (o *GetIndustriesParams) SetProductCategory(productCategory *bool) {
	o.ProductCategory = productCategory
}

// WithServiceCategory adds the serviceCategory to the get industries params
func (o *GetIndustriesParams) WithServiceCategory(serviceCategory *bool) *GetIndustriesParams {
	o.SetServiceCategory(serviceCategory)
	return o
}

// SetServiceCategory adds the serviceCategory to the get industries params
func (o *GetIndustriesParams) SetServiceCategory(serviceCategory *bool) {
	o.ServiceCategory = serviceCategory
}

// WithSlug adds the slug to the get industries params
func (o *GetIndustriesParams) WithSlug(slug *string) *GetIndustriesParams {
	o.SetSlug(slug)
	return o
}

// SetSlug adds the slug to the get industries params
func (o *GetIndustriesParams) SetSlug(slug *string) {
	o.Slug = slug
}

// WriteToRequest writes these params to a swagger request
func (o *GetIndustriesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.IndustryID != nil {

		// query param industryId
		var qrIndustryID string

		if o.IndustryID != nil {
			qrIndustryID = *o.IndustryID
		}
		qIndustryID := qrIndustryID
		if qIndustryID != "" {

			if err := r.SetQueryParam("industryId", qIndustryID); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.ProductCategory != nil {

		// query param productCategory
		var qrProductCategory bool

		if o.ProductCategory != nil {
			qrProductCategory = *o.ProductCategory
		}
		qProductCategory := swag.FormatBool(qrProductCategory)
		if qProductCategory != "" {

			if err := r.SetQueryParam("productCategory", qProductCategory); err != nil {
				return err
			}
		}
	}

	if o.ServiceCategory != nil {

		// query param serviceCategory
		var qrServiceCategory bool

		if o.ServiceCategory != nil {
			qrServiceCategory = *o.ServiceCategory
		}
		qServiceCategory := swag.FormatBool(qrServiceCategory)
		if qServiceCategory != "" {

			if err := r.SetQueryParam("serviceCategory", qServiceCategory); err != nil {
				return err
			}
		}
	}

	if o.Slug != nil {

		// query param slug
		var qrSlug string

		if o.Slug != nil {
			qrSlug = *o.Slug
		}
		qSlug := qrSlug
		if qSlug != "" {

			if err := r.SetQueryParam("slug", qSlug); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
