// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package industry_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDeleteIndustryServiceParams creates a new DeleteIndustryServiceParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteIndustryServiceParams() *DeleteIndustryServiceParams {
	return &DeleteIndustryServiceParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteIndustryServiceParamsWithTimeout creates a new DeleteIndustryServiceParams object
// with the ability to set a timeout on a request.
func NewDeleteIndustryServiceParamsWithTimeout(timeout time.Duration) *DeleteIndustryServiceParams {
	return &DeleteIndustryServiceParams{
		timeout: timeout,
	}
}

// NewDeleteIndustryServiceParamsWithContext creates a new DeleteIndustryServiceParams object
// with the ability to set a context for a request.
func NewDeleteIndustryServiceParamsWithContext(ctx context.Context) *DeleteIndustryServiceParams {
	return &DeleteIndustryServiceParams{
		Context: ctx,
	}
}

// NewDeleteIndustryServiceParamsWithHTTPClient creates a new DeleteIndustryServiceParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteIndustryServiceParamsWithHTTPClient(client *http.Client) *DeleteIndustryServiceParams {
	return &DeleteIndustryServiceParams{
		HTTPClient: client,
	}
}

/*
DeleteIndustryServiceParams contains all the parameters to send to the API endpoint

	for the delete industry service operation.

	Typically these are written to a http.Request.
*/
type DeleteIndustryServiceParams struct {

	/* IndustryServiceID.

	   IndustryService record ID
	*/
	IndustryServiceID *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete industry service params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteIndustryServiceParams) WithDefaults() *DeleteIndustryServiceParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete industry service params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteIndustryServiceParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete industry service params
func (o *DeleteIndustryServiceParams) WithTimeout(timeout time.Duration) *DeleteIndustryServiceParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete industry service params
func (o *DeleteIndustryServiceParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete industry service params
func (o *DeleteIndustryServiceParams) WithContext(ctx context.Context) *DeleteIndustryServiceParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete industry service params
func (o *DeleteIndustryServiceParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete industry service params
func (o *DeleteIndustryServiceParams) WithHTTPClient(client *http.Client) *DeleteIndustryServiceParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete industry service params
func (o *DeleteIndustryServiceParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndustryServiceID adds the industryServiceID to the delete industry service params
func (o *DeleteIndustryServiceParams) WithIndustryServiceID(industryServiceID *string) *DeleteIndustryServiceParams {
	o.SetIndustryServiceID(industryServiceID)
	return o
}

// SetIndustryServiceID adds the industryServiceId to the delete industry service params
func (o *DeleteIndustryServiceParams) SetIndustryServiceID(industryServiceID *string) {
	o.IndustryServiceID = industryServiceID
}

// WithLimit adds the limit to the delete industry service params
func (o *DeleteIndustryServiceParams) WithLimit(limit *int64) *DeleteIndustryServiceParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the delete industry service params
func (o *DeleteIndustryServiceParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the delete industry service params
func (o *DeleteIndustryServiceParams) WithOffset(offset *int64) *DeleteIndustryServiceParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the delete industry service params
func (o *DeleteIndustryServiceParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteIndustryServiceParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.IndustryServiceID != nil {

		// query param industryServiceId
		var qrIndustryServiceID string

		if o.IndustryServiceID != nil {
			qrIndustryServiceID = *o.IndustryServiceID
		}
		qIndustryServiceID := qrIndustryServiceID
		if qIndustryServiceID != "" {

			if err := r.SetQueryParam("industryServiceId", qIndustryServiceID); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
