// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package research_models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// Industry An industry that is being researched
//
// swagger:model Industry
type Industry struct {

	// The list of Products in this industry
	CompanyProducts []*CompanyProduct `json:"CompanyProducts"`

	// The list of Services in this industry
	CompanyServices []*CompanyService `json:"CompanyServices"`

	// Created By User ID
	CreatedByID *string `json:"CreatedByID,omitempty"`

	// Created Date
	CreatedDate *string `json:"CreatedDate,omitempty"`

	// Industry Description
	Description *string `json:"Description,omitempty"`

	// Full Description
	FullDescription *string `json:"FullDescription,omitempty"`

	// Record Id
	ID string `json:"ID,omitempty"`

	// Image Alt Text
	ImageAltText *string `json:"ImageAltText,omitempty"`

	// Image URL
	ImageURL *string `json:"ImageURL,omitempty"`

	// Last Modified By User ID
	LastModifiedByID *string `json:"LastModifiedByID,omitempty"`

	// Last Modified Date
	LastModifiedDate *string `json:"LastModifiedDate,omitempty"`

	// The hierarchical level of this Industry
	Level *string `json:"Level,omitempty"`

	// Logo
	Logo *string `json:"Logo,omitempty"`

	// Industry Name
	Name *string `json:"Name,omitempty"`

	// The ID of the Parent Industry
	ParentIndustryID *string `json:"ParentIndustryID,omitempty"`

	// The full path of this industry, including Parent
	Path *string `json:"Path,omitempty"`

	// Is this industry a product category?
	ProductCategory *bool `json:"ProductCategory,omitempty"`

	// Is this industry a service category?
	ServiceCategory *bool `json:"ServiceCategory,omitempty"`

	// The CMS Slug for this Industry
	Slug *string `json:"Slug,omitempty"`

	// TagLine
	TagLine *string `json:"TagLine,omitempty"`
}

// Validate validates this industry
func (m *Industry) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateCompanyProducts(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCompanyServices(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *Industry) validateCompanyProducts(formats strfmt.Registry) error {
	if swag.IsZero(m.CompanyProducts) { // not required
		return nil
	}

	for i := 0; i < len(m.CompanyProducts); i++ {
		if swag.IsZero(m.CompanyProducts[i]) { // not required
			continue
		}

		if m.CompanyProducts[i] != nil {
			if err := m.CompanyProducts[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("CompanyProducts" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("CompanyProducts" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *Industry) validateCompanyServices(formats strfmt.Registry) error {
	if swag.IsZero(m.CompanyServices) { // not required
		return nil
	}

	for i := 0; i < len(m.CompanyServices); i++ {
		if swag.IsZero(m.CompanyServices[i]) { // not required
			continue
		}

		if m.CompanyServices[i] != nil {
			if err := m.CompanyServices[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("CompanyServices" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("CompanyServices" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this industry based on the context it is used
func (m *Industry) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateCompanyProducts(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateCompanyServices(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *Industry) contextValidateCompanyProducts(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.CompanyProducts); i++ {

		if m.CompanyProducts[i] != nil {
			if err := m.CompanyProducts[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("CompanyProducts" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("CompanyProducts" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *Industry) contextValidateCompanyServices(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.CompanyServices); i++ {

		if m.CompanyServices[i] != nil {
			if err := m.CompanyServices[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("CompanyServices" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("CompanyServices" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *Industry) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *Industry) UnmarshalBinary(b []byte) error {
	var res Industry
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
