// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package industry_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetIndustryServicesParams creates a new GetIndustryServicesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetIndustryServicesParams() *GetIndustryServicesParams {
	return &GetIndustryServicesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetIndustryServicesParamsWithTimeout creates a new GetIndustryServicesParams object
// with the ability to set a timeout on a request.
func NewGetIndustryServicesParamsWithTimeout(timeout time.Duration) *GetIndustryServicesParams {
	return &GetIndustryServicesParams{
		timeout: timeout,
	}
}

// NewGetIndustryServicesParamsWithContext creates a new GetIndustryServicesParams object
// with the ability to set a context for a request.
func NewGetIndustryServicesParamsWithContext(ctx context.Context) *GetIndustryServicesParams {
	return &GetIndustryServicesParams{
		Context: ctx,
	}
}

// NewGetIndustryServicesParamsWithHTTPClient creates a new GetIndustryServicesParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetIndustryServicesParamsWithHTTPClient(client *http.Client) *GetIndustryServicesParams {
	return &GetIndustryServicesParams{
		HTTPClient: client,
	}
}

/*
GetIndustryServicesParams contains all the parameters to send to the API endpoint

	for the get industry services operation.

	Typically these are written to a http.Request.
*/
type GetIndustryServicesParams struct {

	/* Active.

	   Only retrieve active records?
	*/
	Active *bool

	/* IndustryServiceID.

	   IndustryService record ID
	*/
	IndustryServiceID *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get industry services params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetIndustryServicesParams) WithDefaults() *GetIndustryServicesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get industry services params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetIndustryServicesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get industry services params
func (o *GetIndustryServicesParams) WithTimeout(timeout time.Duration) *GetIndustryServicesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get industry services params
func (o *GetIndustryServicesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get industry services params
func (o *GetIndustryServicesParams) WithContext(ctx context.Context) *GetIndustryServicesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get industry services params
func (o *GetIndustryServicesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get industry services params
func (o *GetIndustryServicesParams) WithHTTPClient(client *http.Client) *GetIndustryServicesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get industry services params
func (o *GetIndustryServicesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithActive adds the active to the get industry services params
func (o *GetIndustryServicesParams) WithActive(active *bool) *GetIndustryServicesParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get industry services params
func (o *GetIndustryServicesParams) SetActive(active *bool) {
	o.Active = active
}

// WithIndustryServiceID adds the industryServiceID to the get industry services params
func (o *GetIndustryServicesParams) WithIndustryServiceID(industryServiceID *string) *GetIndustryServicesParams {
	o.SetIndustryServiceID(industryServiceID)
	return o
}

// SetIndustryServiceID adds the industryServiceId to the get industry services params
func (o *GetIndustryServicesParams) SetIndustryServiceID(industryServiceID *string) {
	o.IndustryServiceID = industryServiceID
}

// WithLimit adds the limit to the get industry services params
func (o *GetIndustryServicesParams) WithLimit(limit *int64) *GetIndustryServicesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get industry services params
func (o *GetIndustryServicesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get industry services params
func (o *GetIndustryServicesParams) WithOffset(offset *int64) *GetIndustryServicesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get industry services params
func (o *GetIndustryServicesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetIndustryServicesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Active != nil {

		// query param active
		var qrActive bool

		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {

			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}
	}

	if o.IndustryServiceID != nil {

		// query param industryServiceId
		var qrIndustryServiceID string

		if o.IndustryServiceID != nil {
			qrIndustryServiceID = *o.IndustryServiceID
		}
		qIndustryServiceID := qrIndustryServiceID
		if qIndustryServiceID != "" {

			if err := r.SetQueryParam("industryServiceId", qIndustryServiceID); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
